/******************************************************************************
Module:  AssemInfo.cs
Notices: Copyright (c) 2002 Jeffrey Richter
******************************************************************************/


using System.Reflection;


///////////////////////////////////////////////////////////////////////////////


// Versionsfelder CompanyName, LegalCopyright und
// LegalTrademarks einstellen
[assembly:AssemblyCompany("The Jeffrey Richter Company")]
[assembly:AssemblyCopyright("Copyright (c) 2002 Jeffrey Richter")]
[assembly:AssemblyTrademark(
   "JeffTypes is a registered trademark of the Richter Company")]


///////////////////////////////////////////////////////////////////////////////


// Versionsfelder ProductName und ProductVersion einstellen
[assembly:AssemblyProduct("Jeffrey Richter Type Library")]
[assembly:AssemblyInformationalVersion("2.0.0.0")]


///////////////////////////////////////////////////////////////////////////////


// Versionsfelder FileVersion,
// FileDescription und Comments einstellen
[assembly: AssemblyFileVersion("1.0.0.0")]
[assembly:AssemblyVersion("3.0.0.0")]
[assembly:AssemblyTitle("Jeff's type assembly")]
[assembly:AssemblyDescription("This assembly contains Jeff's types")]


///////////////////////////////////////////////////////////////////////////////


// Feld fr die Kultur einstellen ("" = neutral).
[assembly:AssemblyCulture("")]


///////////////////////////////////////////////////////////////////////////////


#if !StronglyNamedAssembly

// Assemblys mit schwachem Namen werden nie signiert.
[assembly:AssemblyDelaySign(false)]

#else

// Assemblys mit starkem Namen werden normalerweise erst verzgert signiert.
// Erst am Ende wird die eigentliche Signierung 
// mit dem Schalter -R oder -Rc von SN.exe vorgenommen.
[assembly:AssemblyDelaySign(true)]

#if !SignedUsingACryptoServiceProvider

   // Name der Datei mit dem Schlsselpaar aus ffentlichem/privaten Schlssel.
   // Beim verzgerten Signieren wird nur der ffentlichen Schlssel benutzt.
   [assembly:AssemblyKeyFile("MyCompany.keys")]

   // Hinweis: Falls sowohl AssemblyKeyFile als auch AssemblyKeyName angegeben werden, 
   // passiert Folgendes:
   // 1) Falls der Container vorhanden ist, wird die Schlsseldatei ignoriert.
   // 2) Falls der Container nicht vorhanden ist, werden die Schlssel aus der 
   //    Schlsseldatei in den Container kopiert und die Assembly wird signiert.

#else

   // Namen des Cryptographic Service Provider (CSP)-Containers angeben, 
   // der das Schlsselpaar aus ffentlichem/privaten Schlssel enthlt. 
   // Beim verzgerten Signieren wird nur der ffentlichen Schlssel benutzt.
   [assembly:AssemblyKeyName("")]

#endif

#endif


//////////////////////////////// Dateiende  //////////////////////////////////
