using System;

// Dieser Typ ist implizit von System.Object abgeleitet.
internal class Employee {
}

internal class Manager : Employee {
}

public static class Program {
   public static void Main() {
      // Keine Konvertierung ntig, da new ein Employee-Objekt
      // zurckgibt und Object ein Basistyp von Employee ist.
      Object o = new Employee();

      // Konvertierung ntig, da Employee von Object abgeleitet ist.
      // Andere Sprachen (etwa Visual Basic) brauchen eine solche
      // Konvertierung nicht immer.
      Employee e = (Employee) o;
   }

   public static void Main2() {
       // Legt ein Manager-Objekt an und bergibt es an PromoteEmployee.
       // Ein Manager IST vom Typ Object: PromoteEmployee luft einwandfrei.
       Manager m = new Manager();
       PromoteEmployee(m);

       // Legt ein DateTime-Objekt an und bergibt es an PromoteEmployee.
       // Ein DateTime-Objekt ist NICHT von Employee abgeleitet:
       // PromoteEmployee lst die Ausnahme System.InvalidCastException aus.
       DateTime newYears = new DateTime(2007, 1, 1);
       PromoteEmployee(newYears);
   }


   public static void PromoteEmployee(Object o) {
       // An dieser Stelle wei der Compiler nicht genau, welchen
       // Typ das Objekt o hat. Daher bersetzt der Compiler den Code.
       // Whrend der Laufzeit wei die CLR allerdings, welchen Typ o
       // hat (bei jeder Konvertierung) und berprft, ob das Objekt
       // vom Typ Employee ist oder von einem Typ, der von Employee
       // abgeleitet ist.
       Employee e = (Employee)o;
   }

   public static void PromoteEmployee2(Object o) {
      if (o is Employee) {
         Employee e = (Employee)o;
         // Benutzen Sie innerhalb der 'if'-Anweisung das Objekt e. 
      }
   }
   public static void PromoteEmployee3(Object o) {
      Employee e = o as Employee;
      if (e != null) {
          // Benutzen Sie innerhalb der 'if'-Anweisung das Objekt e. 
      }
   }
}
