using System;
using System.Collections;

public static class Program {
   public static void Main(string[] args) {
      ArrayList a = new ArrayList();
      Point p;            // Point anlegen (nicht auf dem Heap).
      for (Int32 i = 0; i < 10; i++) {
          p.x = p.y = i;   // Member im Werttyp initialisieren.
          a.Add(p);        // Werttyp schachteln und den Verweis zur
                           // Arraylist hinzufgen.
      }
   }

   // Einen Werttyp deklarieren.
   private struct Point {
      public Int32 x, y;
   }

   public static void Main2() {
      Int32 x = 5;
      Object o = x;         // x schachteln; o verweist auf das geschachtelte Objekt
      Int16 y = (Int16)o; // Lst eine InvalidCastException aus
   }

   public static void Main3() {
      Int32 x = 5;
      Object o = x;                // x schachteln; o verweist auf das geschachtelte Objekt
      Int16 y = (Int16)(Int32)o; // In den korrekten Typ entschachteln und konvertieren
   }

   public static void Main4() {
       Point p;
       p.x = p.y = 1;
       Object o = p;   // p schachteln; o verweist auf die geschachtelte Instanz

       p = (Point)o;  // o entschachteln UND Felder aus der geschachtelten Instanz
       // in die Stackvariable kopieren
   }

   public static void Main5() {
       Point p;
       p.x = p.y = 1;
       Object o = p;   // p schachteln; o verweist auf die geschachtelte Instanz

       // Feld x im Point zu 2 ndern
       p = (Point)o;  // o entschachteln UND Felder aus der geschachtelten Instanz
       // in die Stackvariable kopieren
       p.x = 2;        // Zustand der Stackvariablen wird verndert.
       o = p;          // p schachteln; o verweist auf die neue geschachtelte Instanz
   }

   public static void Main6() {
       Int32 v = 5;            // Eine nicht geschachtelte Werttypvariable anlegen.
       Object o = v;            // o verweist auf ein geschachteltes Int32 mit dem Wert 5.
       v = 123;                 // ndert den nicht geschachtelten Wert in 123

       Console.WriteLine(v + ", " + (Int32)o); // Zeigt "123, 5" an
   }
   public static void Main7() {
       Int32 v = 5;                // Eine nicht geschachtelte Werttypvariable anlegen.
       Object o = v;               // o verweist auf die geschachtelte Version von v.

       v = 123;                    // ndert den nicht geschachtelten Werttyp auf 123.
       Console.WriteLine(v);       // Zeigt "123" an.

       v = (Int32)o;              // Entschachtelt und kopiert o in v.
       Console.WriteLine(v);       // Zeigt "5" an.
   }

   public static void Main8() {
       Int32 v = 5;   // Eine nicht geschachtelte Werttypvariable anlegen.

#if INEFFICIENT
      // Beim Kompilieren der folgenden Zeile wird v dreimal
      // geschachtelt: eine Verschwendung von Zeit und Speicher
      Console.WriteLine("{0}, {1}, {2}", v, v, v);
#else
       // Diese Zeilen liefern dasselbe Ergebnis, laufen aber
       // viel schneller und verbrauchen weniger Speicher.
       Object o = v;  // v von Hand schachteln (nur einmal)

       // Beim Kompilieren der folgenden Zeile wird nicht geschachtelt.
       Console.WriteLine("{0}, {1}, {2}", o, o, o);
#endif
   }
}
