using System;

// Schnittstelle, die eine Methode namens Change definiert
internal interface IChangeBoxedPoint {
   void Change(Int32 x, Int32 y);
}


// Point ist ein Werttyp.
internal struct Point : IChangeBoxedPoint {
   private Int32 m_x, m_y;

   public Point(Int32 x, Int32 y) {
      m_x = x;
      m_y = y;
   }

   public void Change(Int32 x, Int32 y) {
      m_x = x; m_y = y;
   }

   public override String ToString() {
      return String.Format("({0}, {1})", m_x, m_y);
   }
}

public static class Program {
   public static void Main() {
      Point p = new Point(1, 1);

      Console.WriteLine(p);

      p.Change(2, 2);
      Console.WriteLine(p);

      Object o = p;
      Console.WriteLine(o);

      ((Point)o).Change(3, 3);
      Console.WriteLine(o);

      // p wird geschachtelt, das geschachtelte Objekt wird gendert und verworfen.
      ((IChangeBoxedPoint)p).Change(4, 4);
      Console.WriteLine(p);

      // Das geschachtelte Objekt wird gendert und angezeigt.
      ((IChangeBoxedPoint)o).Change(5, 5);
      Console.WriteLine(o);
   }
}
