/******************************************************************************
Module:  BoxingAndInterfaces.cs
Notices: Copyright (c) 2002 Jeffrey Richter
******************************************************************************/


using System;


///////////////////////////////////////////////////////////////////////////////


struct Point : ICloneable {
   public Int32 x, y;
   
   // berschreibung der Methode ToString, die von System.ValueType geerbt wurde.
   public override String ToString() {
      return String.Format("({0}, {1})", x, y);
   }

   // Implementierung der Methode Clone der Schnittstelle ICloneable
   public Object Clone() {
      return MemberwiseClone();
   }
}


///////////////////////////////////////////////////////////////////////////////


class App {
   static void Main() {
      // Eine Instanz des Werttyps Point auf dem Stack anlegen.
      Point p;

      // Felder der Instanz initialisieren.
      p.x = 10;
      p.y = 20;

      // p wird NICHT geschachtelt, wenn ToString aufgerufen wird.
      Console.WriteLine(p.ToString());

      // p WIRD geschachtelt, wenn GetType aufgerufen wird.
      Console.WriteLine(p.GetType());

      // p wird NICHT geschachtelt, wenn Clone aufgerufen wird.
      // Clone gibt ein Objekt zurck, das entschachtelt wird,
      // und seine Felder werden in p2 kopiert.
      Point p2 = (Point) p.Clone();

      // p2 WIRD geschachtelt und der Verweis wird in c gespeichert.
      ICloneable c = p2;

      // c wird NICHT geschachtelt, weil es bereits geschachtelt ist.
      // Clone gibt einen Verweis auf ein Objekt zurck, das in o gespeichert wird.
      Object o = c.Clone();

      // o wird entschachtelt und die Felder werden in p kopiert.
      p = (Point) o;
   }
}


//////////////////////////////// Dateiende //////////////////////////////////
