/******************************************************************************
Module:  TypesOfTypes.cs
Notices: Copyright (c) 2002 Jeffrey Richter
******************************************************************************/


using System;


///////////////////////////////////////////////////////////////////////////////


class App {
   static public void Main() {
      Console.WriteLine("\n----- Primitive Type Demo -----");
      PrimitiveDemo();

      Console.WriteLine("\n----- Value Type Demo -----");
      ValueTypeDemo();

      Console.WriteLine("\n----- Boxing Demo -----");
      BoxingDemo();
   }


///////////////////////////////////////////////////////////////////////////////


   static void PrimitiveDemo() {
      // Die folgenden 4 Zeilen generieren identischen IL-Code.
      int          a = new int();
      int          b = 0;
      System.Int32 c = new System.Int32();
      Int32        d = 0;

      // Zeigen, dass alle Variablen den Wert 0 enthalten.
      Console.WriteLine("a = {0}, b = {1}, c = {2}, d = {3}", 
         new Object[] { a, b, c, d });

      // Allen Variablen den Wert 5 zuweisen.
      a = b = c = d = 5;
      // Zeigen, dass alle Variablen den Wert 5 enthalten.
      Console.WriteLine("a = {0}, b = {1}, c = {2}, d = {3}", 
         new Object[] { a, b, c, d });
   }


///////////////////////////////////////////////////////////////////////////////


   // Verweistyp (wegen 'class')
   class  SomeRef { public int x; }

   // Werttyp (wegen 'struct')
   struct SomeVal { public int x; }

   static void ValueTypeDemo() {
      SomeRef r1 = new SomeRef();   // Auf dem Heap angelegt
      SomeVal v1 = new SomeVal();   // Auf dem Stack angelegt
      r1.x = 5;                     // Dereferenzieren des Zeigers
      v1.x = 5;                     // Auf dem Stack gendert
      SomeRef r2 = r1;              // Kopiert nur den Verweis
      SomeVal v2 = v1;              // Auf dem Stack angelegt & Member kopiert
      r1.x = 8;                     // ndert r1 und r2
      v1.x = 8;                     // ndert v1, nicht v2

      // Werte aller Variablen anzeigen
      Console.WriteLine("r1.x = {0}, r2.x = {1}, v1 = {2}, v2 = {3}",
         new Object[] { r1.x, r2.x, v1.x, v2.x });
   }


///////////////////////////////////////////////////////////////////////////////


   static void BoxingDemo() {
      Int32  a = 5;  // Ungeschachtelte Werttypvariable anlegen
      Object o = a;  // o verweist auf eine geschachtelte Version von a
      a = 123;       // Den ungeschachtelten Wert zu 123 ndern
      Console.WriteLine(a + ", " + (Int32) o);  // Zeigt "123, 5" an
      Console.WriteLine(a + ", " + o);	         // Besser

      Console.WriteLine(a);   // Kein Boxing
   }
}


//////////////////////////////// Dateiende //////////////////////////////////
