// Entfernen Sie immer nur bei einem der folgenden 4 Symbole das Kommentarzeichen
#define V1
//#define V2a
//#define V2b
//#define V2c


///////////////////////////////////////////////////////////////////////


using System;


///////////////////////////////////////////////////////////////////////


public sealed class Program {
	public static void Main() {
		CompanyB.BetterPhone phone = new CompanyB.BetterPhone();
		phone.Dial();
	}
}


///////////////////////////////////////////////////////////////////////



#if V1
namespace CompanyA {
	public class Phone {
		public void Dial() {
			Console.WriteLine("Phone.Dial");
            // Telefonnummer whlen.
		}
	}
}


namespace CompanyB {
	public class BetterPhone : CompanyA.Phone {

        // Diese Dial-Methode hat nichts mit der Dial-Methode von Phone zu tun.
		new public void Dial() { 
			Console.WriteLine("BetterPhone.Dial");
			EstablishConnection();
			base.Dial();
		}

		protected virtual void EstablishConnection() {
			Console.WriteLine("BetterPhone.EstablishConnection");
            // Verbindung herstellen.
		}
	}
}
#endif


///////////////////////////////////////////////////////////////////////


#if V2a || V2b || V2c
namespace CompanyA {
	public class Phone {
		public void Dial() {
			Console.WriteLine("Phone.Dial");
			EstablishConnection();
			// Telefonnummer whlen.
		}

		protected virtual void EstablishConnection() {
	      Console.WriteLine("Phone.EstablishConnection");
		   // Verbindung herstellen.
		}
	}
}
#endif


///////////////////////////////////////////////////////////////////////


#if V2a
namespace CompanyB {
	public class BetterPhone : CompanyA.Phone {

        // 'new' bedeutet, dass diese Dial-Methode nichts mit
        // der Dial-Methode des Basistyps Phone zu tun hat.
		new public void Dial() { 
			Console.WriteLine("BetterPhone.Dial");
			EstablishConnection();
			base.Dial();
		}

        // Schlsselwort 'new' neu hinzugefgt.
        // 'new' bedeutet, dass diese Methode nichts mit der
        // EstablishConnection-Methode des Basistyps zu tun hat.
		new protected virtual void EstablishConnection() {
			Console.WriteLine("BetterPhone.EstablishConnection");
			// Verbindung herstellen.
		}
	}
}
#endif


#if V2b
namespace CompanyB {
	public class BetterPhone : CompanyA.Phone {
		// Methode Dial gelscht (Dial wird jetzt von der Basisklasse geerbt).

        // 'new' gelscht und 'virtual' durch 'override' ersetzt. Auf diese Weise
        // wird dem Compiler mitgeteilt, dass diese Methode mit der EstablishConnection-
        // Methode des Basistyps in Verbindung steht.
		protected override void EstablishConnection() {
			Console.WriteLine("BetterPhone.EstablishConnection");
			// Verbindung herstellen.
		}
	}
}
#endif


#if V2c
namespace CompanyB {
	public class BetterPhone : CompanyA.Phone {

        // 'new' bedeutet, dass diese Dial-Methode nichts mit
        // der Dial-Methode des Basistyps Phone zu tun hat.
		new public void Dial() { 
			Console.WriteLine("BetterPhone.Dial");
			EstablishConnection();
			base.Dial();
		}

        // 'new' gelscht und 'virtual' durch 'override' ersetzt. Auf diese Weise
        // wird dem Compiler mitgeteilt, dass diese Methode mit der EstablishConnection-
        // Methode des Basistyps in Verbindung steht.
		protected override void EstablishConnection() {
			Console.WriteLine("BetterPhone.EstablishConnection");
			// Verbindung herstellen.
		}
	}
}
#endif