﻿using System;

public sealed class SomeType
{
   // Ein statisches schreibgeschütztes Feld. Sein Wert wird
   // berechnet und gespeichert, wenn die Klasse während der
   // Laufzeit initialisiert wird.
   public static readonly Random s_random = new Random();

   // Ein statisches Feld, das gelesen und geändert werden kann.
   private static Int32 s_numberOfWrites = 0;

   // Ein schreibgeschütztes Instanzfeld.
   public readonly String Pathname = "Untitled";

   // Ein Instanzfeld, das gelesen und geändert werden kann.
   private System.IO.FileStream m_fs;

   public SomeType(String pathname)
   {
      // Diese Zeile ändert ein schreibgeschütztes Feld.
      // Das ist in Ordnung, weil es sich um einen Konstruktor handelt.
      this.Pathname = pathname;
   }

   public String DoSomething()
   {
      // Diese Zeile liest und ändert das statische Feld.
      s_numberOfWrites = s_numberOfWrites + 1;

      // Diese Zeile liest das schreibgeschützte Instanzfeld.
      return Pathname;
   }
}
