﻿using System;

namespace Example1 {
	internal sealed class SomeType {
		private Int32 m_x = 5;
	}
}


namespace Example2 {
	internal sealed class SomeType {
		private Int32  m_x = 5;
		private String m_s = "Hi there";
		private Double m_d = 3.14159;
		private Byte   m_b;

      // Einige Konstruktoren. 
		public SomeType()         { /* ... */ }
		public SomeType(Int32 x)  { /* ... */ }
		public SomeType(String s) { /* ...; */ m_d = 10; }
	}
}


namespace Example3 {
   internal sealed class SomeType
   {
      // Die Felder werden hier nicht explizit initialisiert.
      private Int32 m_x;
      private String m_s;
      private Double m_d;
      private Byte m_b;

      // Dieser Konstruktor weist allen Feldern ihre Standardwerte zu.
      // Alle anderen Konstruktoren rufen explizit diesen Konstruktor auf.
      public SomeType()
      {
         m_x = 5;
         m_s = "Hi there";
         m_d = 3.14159;
         m_b = 0xff;
      }

      // Dieser Konstruktor weist allen Feldern ihre Standardwerte zu und ändert dann m_x.
      public SomeType(Int32 x)
         : this()
      {
         m_x = x;
      }

      // Dieser Konstruktor weist allen Feldern ihre Standardwerte zu und ändert dann m_s.
      public SomeType(String s)
         : this()
      {
         m_s = s;
      }

      // Dieser Konstruktor weist allen Feldern ihre Standardwerte zu und ändert dann m_x & m_s.
      public SomeType(Int32 x, String s)
         : this()
      {
         m_x = x;
         m_s = s;
      }
   }
}



internal struct SomeValType {
	static SomeValType() {
		Console.WriteLine("Dies wird niemals angezeigt.");
	}
	public Int32 m_x;
}

public sealed class Program {
	public static void Main() {
		SomeValType[] a = new SomeValType[10];
		a[0].m_x = 123;
		Console.WriteLine(a[0].m_x);	// Zeigt 123 an.
	}
}
