﻿#define V1
//#define V2
//#define V3


using System;


///////////////////////////////////////////////////////////////////////////////


namespace PassingValueTypesByReference {
	public sealed class Program {
#if V1
		public static void Main() {
         Int32 x;               // x ist nicht initialisiert.
         GetVal(out x);         // x muss nicht initialisiert werden.
         Console.WriteLine(x);  // Zeigt "10" an
      }

      private static void GetVal(out Int32 v)
      {
         v = 10;  // Diese Methode muss v initialisieren.
      }
#endif
#if V2
		public static void Main() {
         Int32 x = 5;          // x ist initialisiert.
         AddVal(ref x);        // x muss initialisiert werden.
         Console.WriteLine(x); // Zeigt "15" an.
      }

      private static void AddVal(ref Int32 v) {
         v += 10;  // Diese Methode kann den anfänglichen Wert in v verarbeiten.
      }
#endif
#if V3
		public static void Main() {
         Int32 x;              // x ist nicht initialisiert.

         // Die folgende Zeile führt zu einem Fehler:
         // Fehler CS0165: Verwendung von nicht zugewiesenen lokalen Variablen 'x'.
         AddVal(ref x);

         Console.WriteLine(x);
      }

      private static void AddVal(ref Int32 v) {
         v += 10;  // Diese Methode kann den anfänglichen Wert in v verarbeiten.
      }
#endif

      public static void Swap(ref Object a, ref Object b) {
			Object t = b;
			b = a;
			a = t;
		}

#if true
		public static void SomeMethod() {
			String s1 = "Jeffrey";
			String s2 = "Richter";
			Swap(ref s1, ref s2);
			Console.WriteLine(s1);  // Zeigt "Richter" an.
         Console.WriteLine(s2);  // Zeigt "Jeffrey" an.
		}
#endif

		public static void SomeMethod2() {
			String s1 = "Jeffrey";
			String s2 = "Richter";

         // Variablen, die als Verweis übergeben werden,
         // müssen genau den Typ haben, den die Methode erwartet.
         Object o1 = s1, o2 = s2;
         Swap(ref o1, ref o2);

         // Jetzt die Objekte zurück in Strings konvertieren.
         s1 = (String)o1;
			s2	= (String) o2;

         Console.WriteLine(s1);  // Zeigt "Richter" an.
         Console.WriteLine(s2);  // Zeigt "Jeffrey" an.
		}

		public static void Swap<T>(ref T a, ref T b) {
			T t = b;
			b = a;
			a = t;
		}
	}
}


///////////////////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////////////////////////


public sealed class Point {
   static void Add(Point p) { /* ... */ }
   static void Add(ref Point p) { /* ... */ }

	// Für 'Add' dürfen keine Überladungen definiert werden, die sich nur 
   // durch ref und out unterscheiden:
	// static void Add(out Point p) { /* ... */ }
}


///////////////////////////////////////////////////////////////////////////////



////////////////////////////// Dateiende ////////////////////////////////////
