using System;

internal sealed class Employee {
   private String m_Name; // 'm_' vorangestellt, um Konflikt zu vermeiden
   private Int32  m_Age;  // 'm_' vorangestellt, um Konflikt zu vermeiden

   public String Name {
      get { return(m_Name); }
      set { m_Name = value; } // Das Schlsselwort 'value' steht immer fr den neuen Wert.
   }

   public Int32 Age {
      get { return(m_Age); }
      set {
         if (value <= 0)    // Das Schlsselwort 'value' steht immer fr den neuen Wert.
            throw new ArgumentOutOfRangeException("value", "must be >0");
         m_Age = value;
      }
   }
}


public sealed class Program {
	public static void Main() {
      Employee emp = new Employee();
      emp.Name = "Jeffrey Richter";
      emp.Age = 36;	   // Das Alter aktualisieren
      Console.WriteLine("Info ber den Angestellten: Name = {0}, Alter = {1}", emp.Name, emp.Age);

      try {
         emp.Age = -5;	   // Lst eine Ausnahme aus.
      }
      catch (ArgumentOutOfRangeException e) {
         Console.WriteLine(e);
      }
      Console.WriteLine("Info ber den Angestellten: Name = {0}, Alter = {1}", emp.Name, emp.Age);
   }
}
