using System;

public static class Program {
   public static void Main()
   {
      Char c;
      Int32 n;

      // Umwandlung Zahl <-> Zeichen mit C#-Typkonvertierung
      c = (Char)65;
      Console.WriteLine(c);                  // Zeigt "A" an

      n = (Int32)c;
      Console.WriteLine(n);                  // Zeigt "65" an

      c = unchecked((Char)(65536 + 65));
      Console.WriteLine(c);                  // Zeigt "A" an

      // Umwandlung Zahl <-> Zeichen mit Convert
      c = Convert.ToChar(65);
      Console.WriteLine(c);                  // Zeigt "A" an

      n = Convert.ToInt32(c);
      Console.WriteLine(n);                  // Zeigt "65" an

      // Ein Beispiel fr die Bereichsberprfung von Convert
      try
      {
         c = Convert.ToChar(70000);          // Zu gro fr 16 Bits
         Console.WriteLine(c);               // Wird bersprungen
      }
      catch (OverflowException)
      {
         Console.WriteLine("Kann 70000 nicht in einen Char konvertieren.");
      }

      // Umwandlung Zahl <-> Zeichen mit IConvertible
      c = ((IConvertible)65).ToChar(null);
      Console.WriteLine(c);                  // Zeigt "A" an

      n = ((IConvertible)c).ToInt32(null);
      Console.WriteLine(n);                  // Zeigt "65" an
   }
}
