using System;
using System.Text;
using System.IO;

public static class Program {
	public static void Main(String[] args) {
		if (args.Length != 4) {
			Console.WriteLine(
				"CodePageConverter <Quelldatei> <QuellCodepage> <Zieldatei> <ZielCodepage>{0}{0}" +
				"Beispiele:{0}" +
				"   CodePageConverter InFile.txt 65001 OutFile.txt 1200{0}" +
				"      => Konvertiert aus UTF-8 (Codepage 65001) in UTF-16 (Little Endian){0}{0}" +
				"   CodePageConverter InFile.txt 932 OutFile.txt UTF-8{0}" +
            "      => Konvertiert aus Shift-Jis (codepage 932) in UTF-8",
				Environment.NewLine);
			return;
		}

		// Quellstream mit der angegebenen Kodierung ffnen
		StreamReader srcText = new StreamReader(args[0], GetEncoding(args[1]));

      // Zielstream mit der angegebenen Kodierung erstellen
		StreamWriter dstText = new StreamWriter(args[2], false, GetEncoding(args[3]));

		// Aus dem Quellstream lesen und in den Zielstream schreiben
		dstText.Write(srcText.ReadToEnd());

		// Beide Streams schlieen
		srcText.Close();
		dstText.Close();
	}

	static Encoding GetEncoding(String s) {
		try {
			// Falls der Benutzer ein Integer bergeben hat, das die Codepage bestimmt.
			return Encoding.GetEncoding(Int32.Parse(s));
		}
		catch (FormatException) {
			// Der Benutzer hat keinen gltigen Integerwert fr die Codepage angegeben.
		}

      // Falls der Benutzer einen String bergeben hat, der die Codepage bestimmt.
		return Encoding.GetEncoding(s);
	}
}
