using System;
using System.Security;
using System.Runtime.InteropServices;

public static class Program
{
   public static void Main()
   {
      using (SecureString ss = new SecureString())
      {
         Console.Write("Bitte geben Sie das Kennwort ein: ");
         while (true)
         {
            ConsoleKeyInfo cki = Console.ReadKey(true);
            if (cki.Key == ConsoleKey.Enter) break;

            // Kennwortzeichen an den SecureString anhngen.
            ss.AppendChar(cki.KeyChar);
            Console.Write("*");
         }
         Console.WriteLine();

         // Kennwort wurde eingeben. Wir zeigen es jetzt an.
         DisplaySecureString(ss);
      }
      // Nach dem 'using'-Block wird der SecureString beseitigt.
      // Es verbleiben keine vertraulichen Daten im Speicher.
   }

   // Diese Methode ist unsicher, weil sie auf nicht verwalteten Speicher zugreift.
   private unsafe static void DisplaySecureString(SecureString ss)
   {
      Char* pc = null;
      try
      {
         // Den SecureString in einen Puffer im unverwalteten Speicher entschlsseln.
         pc = (Char*)Marshal.SecureStringToCoTaskMemUnicode(ss);

         // Auf den Puffer im unverwalteten Speicher zugreifen, der
         // den entschlsselten SecureString enthlt.
         for (Int32 index = 0; pc[index] != 0; index++)
            Console.Write(pc[index]);
      }
      finally
      {
         // Sicherstellen, dass wir den Puffer im unverwalteten
         // Speicher, der die entschlsselten Zeichen des SecureString
         // enthlt, mit Nullbytes berschreiben.
         if (pc != null)
            Marshal.ZeroFreeCoTaskMemUnicode((IntPtr)pc);
      }
   }
}
