using System;
using System.IO;


[Flags] 	// Der C#-Compiler akzeptiert "Flags" oder "FlagsAttribute".
public enum Actions {
   Read   = 0x0001,
   Write  = 0x0002,
   Delete = 0x0004,
   Query  = 0x0008,
   Sync   = 0x0010 
}

public static class Program {
   public static void Main() {
      String file = @"C:\Boot.ini";
      FileAttributes attributes = File.GetAttributes(file);
      Console.WriteLine("Ist {0} versteckt? {1}", file,
         (attributes & FileAttributes.Hidden) == FileAttributes.Hidden);

      Actions actions = Actions.Read | Actions.Write; // 0x0003
      Console.WriteLine(actions.ToString());          // "Read, Write" 

      // Da Query als 8 definiert ist, wird 'a' mit 8 initialisiert.
      Actions a = (Actions) Enum.Parse(typeof(Actions), "Query", true);

      // Da Query und Read definiert sind, wird 'a' mit 9 initialisiert.
      a = (Actions) Enum.Parse(typeof(Actions), "Query, Read", false);

      // Legt eine Instanz des Enumerationstyps Actions an, die den Wert 28 hat.
      a = (Actions) Enum.Parse(typeof(Actions), "28", false);
      Console.WriteLine(a.ToString());  // "Delete, Query, Sync"

      a = (Actions) Enum.Parse(typeof(Actions), "Delete, Sync");
      Console.WriteLine(a.ToString());
   }
}