using System;

public static class Program {
   public static void Main() {
      StackallocDemo();
      InlineArrayDemo();
   }

   private static void StackallocDemo()
   {
      unsafe
      {
         const Int32 width = 20;
         Char* pc = stackalloc Char[width]; // Array auf dem Stack anlegen

         String s = "Jeffrey Richter";      // 15 Zeichen

         for (Int32 index = 0; index < width; index++)
         {
            pc[width - index - 1] =
               (index < s.Length) ? s[index] : '.';
         }

         // Zeigt an: ".....rethciR yerffeJ"
         Console.WriteLine(new String(pc, 0, width));
      }
   }

   private static void InlineArrayDemo()
   {
      unsafe
      {
         CharArray ca;                 // Array auf dem Stack anlegen
         Int32 widthInBytes = sizeof(CharArray);
         Int32 width = widthInBytes / 2;

         String s = "Jeffrey Richter"; // 15 Zeichen

         for (Int32 index = 0; index < width; index++)
         {
            ca.Characters[width - index - 1] =
               (index < s.Length) ? s[index] : '.';
         }

         // Zeigt an: ".....rethciR yerffeJ"
         Console.WriteLine(new String(ca.Characters, 0, width));
      }
   }
}

internal unsafe struct CharArray
{
   // Dieses Array ist im Inline-Format in die Struktur eingebettet.
   public fixed Char Characters[20];
}
