﻿using System;


// Point ist von System.Object abgeleitet und implementiert IComparable<T> für Point.
public sealed class Point : IComparable<Point>
{
   private Int32 m_x, m_y;

   public Point(Int32 x, Int32 y)
   {
      m_x = x;
      m_y = y;
   }

   // Diese Methode implementiert IComparable<T> für Point.
   public Int32 CompareTo(Point other)
   {
      return Math.Sign(Math.Sqrt(m_x * m_x + m_y * m_y)
         - Math.Sqrt(other.m_x * other.m_x + other.m_y * other.m_y));
   }

   public override String ToString()
   {
      return String.Format("({0}, {1})", m_x, m_y);
   }
}

public static class Program
{
   public static void Main()
   {
      Point[] points = new Point[] {
         new Point(3, 3),
         new Point(1, 2),
      };

      // Hier ein Aufruf der Point-Methode CompareTo aus der Schnittstelle IComparable<T>
      if (points[0].CompareTo(points[1]) > 0)
      {
         Point tempPoint = points[0];
         points[0] = points[1];
         points[1] = tempPoint;
      }
      Console.WriteLine("Point-Koordinaten von nah (0, 0) bis weit weg:");
      foreach (Point p in points)
         Console.WriteLine(p);
   }
}
