using System;

public static class Program
{
   public static void Main()
   {
      /************************* Erstes Beispiel *************************/
      Base b = new Base();

      // Ruft Dispose ber den Typ von b auf: "Dispose von Base"
      b.Dispose();

      // Ruft Dispose ber den Objekttyp von b auf: "Dispose von Base"
      ((IDisposable)b).Dispose();

      /************************* Zweites Beispiel ************************/
      Derived d = new Derived();

      // Ruft Dispose ber den Typ von d auf: "Dispose von Derived"
      d.Dispose();

      // Ruft Dispose ber den Objekttyp von d auf: "Dispose von Derived"
      ((IDisposable)d).Dispose();

      /************************* Drittes Beispiel ************************/
      b = new Derived();

      // Ruft Dispose ber den Typ von b auf: "Dispose von Base"
      b.Dispose();

      // Ruft Dispose ber den Objekttyp von b auf: "Dispose von Derived"
      ((IDisposable)b).Dispose();
   }
}

// Diese Klasse ist von Object abgeleitet und implementiert IDisposable.
internal class Base : IDisposable
{
   // Diese Methode ist implizit versiegelt und kann nicht berschrieben werden.
   public void Dispose()
   {
      Console.WriteLine("Dispose von Base");
   }
}

// Diese Klasse ist von Base abgeleitet und implementiert IDisposable neu.
internal class Derived : Base, IDisposable
{
   // Diese Methode kann die Dispose-Methode von Base nicht berschreiben.
   // Es wird 'new' verwendet, um einzustellen, dass diese Methode
   // die Dispose-Methode von IDisposable neu implementiert
   new public void Dispose()
   {
      Console.WriteLine("Dispose von Derived");

      // HINWEIS: Die nchste Zeile zeigt, wie Sie die Implementierung der
      // Basisklasse aufrufen knnen (sofern gewnscht):
      // base.Dispose();
   }
}
