using System;
using System.Collections.Generic;

public static class Program {
   public static void Main() {
      Object o = null;

      // Dictionary<,> ist ein offener Typ mit 2 Typparametern.
      Type t = typeof(Dictionary<,>);

      // Versuchen, eine Instanz dieses Typs zu erstellen (schlgt fehl).
      o = CreateInstance(t);
      Console.WriteLine();

      // DictionaryStringKey<> ist ein offener Typ mit 1 Typparameter.
      t = typeof(DictionaryStringKey<>);

      // Versuchen, eine Instanz dieses Typs zu erstellen (schlgt fehl).
      o = CreateInstance(t);
      Console.WriteLine();

      // DictionaryStringKey<Guid> ist ein geschlossener Typ.
      t = typeof(DictionaryStringKey<Guid>);

      // Versuchen, eine Instanz dieses Typs zu erstellen (erfolgreich).
      o = CreateInstance(t);

      // Beweisen, dass es tatschlich funktioniert hat.
      Console.WriteLine("Objekttyp=" + o.GetType());
   }

   private static Object CreateInstance(Type t) {
      Object o = null;
      try {
         o = Activator.CreateInstance(t);
         Console.Write("Instanz von {0} erzeugt.", t.ToString()); 
      }
      catch (ArgumentException e) {
         Console.WriteLine(e.Message);
      }
      return o;
   }
}


// Ein teilweise spezifizierter offener Typ
internal sealed class DictionaryStringKey<TValue> : 
   Dictionary<String, TValue> {
}