//#define BADCODE

using System;
using System.Threading;

public sealed class Program {
   public static void Main() {
      Int32[] denominators = { 1, 2, 3 };

      // Ein anderer Thread erledigt die Arbeit.
      ThreadPool.QueueUserWorkItem(Divide100By, denominators);

      // DEMO: Divide100By bekommt die Gelegenheit, die Arrayelement zu berprfen.
      Thread.Sleep(50);

      // Ein Arrayelement so verndern, dass es fr die Methode Divide100By ungltig wird.
      denominators[2] = 0;

      Console.WriteLine("Drcken Sie die <Eingabetaste>, wenn Sie die Ergebnisse sehen.");
      Console.ReadLine();
   }

   private static void Divide100By(Object o) {

#if BADCODE
      // Dieser Code demonstriert das Problem.
      Int32[] denominators = (Int32[]) o;
#else
      // Dieser Code beseitigt das Problem, indem er eine Kopie des Arrays anlegt.
      // Die Kopie wird dann berprft und im Rest der Methode benutzt.
      Int32[] denominatorsInput = (Int32[]) o;
      Int32[] denominators = new Int32[denominatorsInput.Length];
      Array.Copy(denominatorsInput, denominators, denominators.Length);
#endif

      // Alle Elemente im Arrayargument berprfen.
      for (Int32 index = 0; index < denominators.Length; index++)
      {
         if (denominators[index] == 0)
            throw new ArgumentOutOfRangeException("denominators",
               String.Format("Index {0} enthlt 0", index));
      }
      Console.WriteLine(
         "Alle Nenner sind gltig, DivideByZeroException kann nicht auftreten.");

      // DEMO: Main die Gelegenheit geben, ein Arrayelement ungltig zu machen.
      Thread.Sleep(100);

      // Alle Element sind gltig, jetzt die Arbeit erledigen.
      for (Int32 index = 0; index < denominators.Length; index++)
      {
         Console.WriteLine("100 / {0} = {1}", 
            denominators[index], 100 / denominators[index]);
      }
   }
}

internal sealed class SomeType {
	internal static Byte[] ReadFileBytes(String path) {
		System.IO.FileStream fs = null;
		try {
			fs = new System.IO.FileStream(path, System.IO.FileMode.Open);
			Byte[] data = new byte[fs.Length];
			fs.Read(data, 0, (Int32) fs.Length);
			return data;
		}
		catch (Exception) {
		}
      // TODO: Blah
      return null;
   }
}