#define Version2
using System;
using System.IO;

public sealed class Program {
#if Version1
   public static void Main() {
      // Die Bytes zusammenstellen, die in die temporre Datei geschrieben werden sollen.
      Byte[] bytesToWrite = new Byte[] { 1, 2, 3, 4, 5 };

      // Die temporre Datei anlegen.
      FileStream fs = new FileStream("Temp.dat", FileMode.Create);

      // Bytes in die temporre Datei schreiben.
      fs.Write(bytesToWrite, 0, bytesToWrite.Length);

      // Die Datei explizit schlieen, nachdem die Bytes geschrieben sind.
      ((IDisposable) fs).Dispose();

      // Die temporre Datei lschen.
      File.Delete("Temp.dat");  // Funktioniert jetzt immer.
   }
#endif


#if Version2
   public static void Main() {
      // Die Bytes zusammenstellen, die in die temporre Datei geschrieben werden sollen.
      Byte[] bytesToWrite = new Byte[] { 1, 2, 3, 4, 5 };

      // Die temporre Datei anlegen.
      FileStream fs = new FileStream("Temp.dat", FileMode.Create);
      try {
         // Bytes in die temporre Datei schreiben.
         fs.Write(bytesToWrite, 0, bytesToWrite.Length);
      }
      finally {
         // Die Datei explizit schlieen, nachdem die Bytes geschrieben sind.
         if (fs != null)
            ((IDisposable)fs).Dispose();
      }

      // Die temporre Datei lschen.
      File.Delete("Temp.dat");  // Funktioniert jetzt immer.
   }
#endif
}
