using System;
using System.Threading;

// Dieser Werttyp kapselt die Mutexsperrung und -entsperrung.
internal struct MutexLock : IDisposable {
   private Mutex m_mutex;

   // Dieser Konstruktor holt eine Sperre fr den Mutex.
   public MutexLock(Mutex m) { 
      m_mutex = m; 
      m_mutex.WaitOne(); 
   }

   // Diese Dispose-Methode gibt die Sperre fr den Mutex frei.
   public void Dispose() {
      m_mutex.ReleaseMutex();
   }
}

public sealed class Program {
   // Diese Methode demonstriert, wie Sie MutexLock sinnvoll nutzen.
   public static void Main() {
      // Ein Mutexobjekt anlegen.
      Mutex m = new Mutex();

      // Den Mutex sperren, etwas tun und den Mutex wieder entsperren.
      using (new MutexLock(m)) {
         // Hier knnen Sie threadsichere Operationen durchfhren...
      }
   }
}
