using System;

internal sealed class GenObj {
   ~GenObj() {
      Console.WriteLine("In der Finalize-Methode"); 
   }
}

public static class Program
{
   public static void Main()
   {
      Console.WriteLine("Maximale Anzahl Generationen: " + GC.MaxGeneration);

      // Ein neues GenObj auf dem Heap anlegen.
      Object o = new GenObj();

      // Da dieses Objekt neu angelegt wurde, liegt es in der Generation 0.
      Console.WriteLine("Generation " + GC.GetGeneration(o)); // 0

      // Bei einer Garbage Collection wird das Objekt in eine hhere Generation befrdert.
      GC.Collect();
      Console.WriteLine("Generation " + GC.GetGeneration(o)); // 1

      GC.Collect();
      Console.WriteLine("Generation " + GC.GetGeneration(o)); // 2

      GC.Collect();
      Console.WriteLine("Generation " + GC.GetGeneration(o)); // 2 (max)

      o = null; // Den starken Verweis auf dieses Objekt zerstren.

      Console.WriteLine("Garbage Collection fr die Generation 0");
      GC.Collect(0);                    // Garbage Collection fr die Generation 0 durchfhren.
      GC.WaitForPendingFinalizers();    // Finalize wird NICHT aufgerufen.

      Console.WriteLine("Garbage Collection fr die Generation 0 und 1");
      GC.Collect(1);                    // Garbage Collection fr die Generationen 0 und 1 durchfhren.
      GC.WaitForPendingFinalizers();    // Finalize wird NICHT aufgerufen.

      Console.WriteLine("Garbage Collection fr die Generationen 0, 1 und 2");
      GC.Collect(2);                    // Entspricht Collect().
      GC.WaitForPendingFinalizers();    // Finalize WIRD aufgerufen.
   }
}
