using System;
using System.Threading;
using System.Runtime.InteropServices;
using System.Diagnostics;

public sealed class Program {
   private const Int32 c_testCode = 0;   // 0=InfiniteLoop, 1=ManagedSleep, 2=UnmanagedSleep
   private static AppDomain s_ad;

   public static void Main() {
      // Eine AppDomain anlegen
      s_ad = AppDomain.CreateDomain("AD #2", null, null);

      // Thread anlegen, der in die andere AppDomain eintreten soll.
      Thread t = new Thread((ThreadStart) delegate { s_ad.DoCallBack(Loop); });
      t.Start();
      Thread.Sleep(5000);  // Der andere Thread kann jetzt eine Weile laufen.

      Stopwatch sw = null;
      try {
         // Messen, wie lange es dauert, die AppDomain zu entladen.
         Console.WriteLine("Aufruf von Unload");
         sw = Stopwatch.StartNew();
         AppDomain.Unload(s_ad);
      }
      catch (Exception e) {
         Console.WriteLine(e.ToString());
      }
      Console.WriteLine("Unload ist nach {0} zurckgekehrt.", sw.Elapsed);
      Console.ReadLine();
   }

   private static void Loop() {
      try {
         switch (c_testCode) {
            case 0: while (true) ; break;	// Endlosschleife
            case 1: Thread.Sleep(10000); break;	// Verwalteter Wartezustand
            case 2: Sleep(10000); break;		// Nicht verwalteter Wartezustand
         }
      }
      catch (ThreadAbortException) {
         Console.WriteLine("ThreadBortException abgefangen: Drcken Sie die Eingabetaste.");
         Console.ReadLine();
      }
   }

   [DllImport("Kernel32")]
   private static extern void Sleep(UInt32 ms);
}
