using System;
using System.Reflection;

public static class Program
{
   public static void Main()
   {
      // In einer Schleife alle Assemblys durchgehen, die in diese AppDomain geladen sind.
      Assembly[] assemblies = AppDomain.CurrentDomain.GetAssemblies();
      foreach (Assembly a in assemblies)
      {
         WriteLine(0, "Assembly: {0}", a);

         // Typen in der Assembly suchen.
         foreach (Type t in a.GetExportedTypes())
         {
            WriteLine(1, "Typ: {0}", t);

            // Member des Typs ermitteln.
            const BindingFlags bf = BindingFlags.DeclaredOnly |
               BindingFlags.NonPublic | BindingFlags.Public |
               BindingFlags.Instance | BindingFlags.Static;

            foreach (MemberInfo mi in t.GetMembers(bf))
            {
               String typeName = String.Empty;
               if (mi is Type) typeName = "(Verschachtelter) Typ";
               else if (mi is FieldInfo) typeName = "FieldInfo";
               else if (mi is MethodInfo) typeName = "MethodInfo";
               else if (mi is ConstructorInfo) typeName = "ConstructoInfo";
               else if (mi is PropertyInfo) typeName = "PropertyInfo";
               else if (mi is EventInfo) typeName = "EventInfo";

               WriteLine(2, "{0}: {1}", typeName, mi);
            }
         }
      }
   }
   private static void WriteLine(Int32 indent, String format,
      params Object[] args)
   {
      Console.WriteLine(new String(' ', 3 * indent) + format, args);
   }
}
