using System;
using System.Threading;

public static class Program
{
   public static void Main()
   {
      Console.WriteLine("Hauptthread: Eine asynchrone Operation in die Warteschlange stellen.");
      ThreadPool.QueueUserWorkItem(ComputeBoundOp, 5);
      Console.WriteLine("Hauptthread: Andere Arbeiten ausfhren...");
      Thread.Sleep(10000);  // Andere Arbeiten simulieren (10 Sekunden)
      Console.WriteLine("Drcken Sie die <Eingabetaste>, um das Programm zu beenden...");
      Console.ReadLine();
   }

   // Die Signatur dieser Methode muss dem Delegaten WaitCallback entsprechen.
   private static void ComputeBoundOp(Object state)
   {
      // Diese Methode wird von einem Thread aus dem Threadpool ausgefhrt.

      Console.WriteLine("In ComputeBoundOp: state={0}", state);
      Thread.Sleep(1000);  // Simuliert andere Arbeiten (1 Sekunde).

      // Wenn diese Methode zurckkehrt, kehrt der Thread in den
      // Pool zurck und wartet auf die nchste Aufgabe.
   }
}
