using System;
using System.Threading;

public static class Program
{
   public static void Main()
   {
      Console.WriteLine("Hauptthread: Einen dedizierten Thread starten, " +
         "um eine asynchrone Operation auszufhren.");
      Thread dedicatedThread = new Thread(ComputeBoundOp);
      dedicatedThread.Start(5);

      Console.WriteLine("Hauptthread: Andere Arbeiten ausfhren...");
      Thread.Sleep(10000);     // Andere Arbeiten simulieren (10 Sekunden).

      dedicatedThread.Join();  // Warten, bis der Thread beendet ist.
      Console.WriteLine("Drcken Sie die <Eingabetaste>, um das Programm zu beenden...");
      Console.ReadLine();
   }

   // Die Signatur dieser Methode muss dem Delegaten ParameterizedThreadStart entsprechen.
   private static void ComputeBoundOp(Object state)
   {
      // Diese Methode wird von einem dedizierten Thread ausgefhrt.

      Console.WriteLine("In ComputeBoundOp: state={0}", state);
      Thread.Sleep(1000);  // Simuliert andere Arbeiten (1 Sekunde).

      // Wenn diese Methode zurckkehrt, stirbt der dedizierte Thread.
   }
}
