using System;
using System.Threading;

public static class Program
{
   public static void Main()
   {
      Console.WriteLine("Hauptthread: Timer starten.");
      Timer t = new Timer(ComputeBoundOp, 5, 0, 2000);

      Console.WriteLine("Hauptthread: Andere Arbeiten ausfhren...");
      Thread.Sleep(10000);  // Andere Arbeiten simulieren (10 Sekunden).
      t.Dispose();          // Den Timer beseitigen.
   }

   // Die Signatur dieser Methode muss dem Delegaten TimerCallback entsprechen.
   private static void ComputeBoundOp(Object state)
   {
      // Diese Methode wird von einem Thread aus dem Threadpool ausgefhrt.

      Console.WriteLine("In ComputeBoundOp: state={0}", state);
      Thread.Sleep(1000);  // Simuliert andere Arbeiten (1 Sekunde).

      // Wenn diese Methode zurckkehrt, kehrt der Thread in den
      // Pool zurck und wartet auf die nchste Aufgabe.
   }
}
