using System;
using System.Threading;

public static class Program {

   public static void Main() {
   }
}

internal sealed class CacheCoherencyProblem
{
   private Byte m_initialized = 0;
   private Int32 m_value = 0;

   // Diese Methode wird vom ersten Thread ausgefhrt.
   public void Thread1()
   {
      m_value = 5;
      m_initialized = 1;
   }

   // Diese Methode wird vom zweiten Thread ausgefhrt.
   public void Thread2()
   {
      if (m_initialized == 1)
      {
         // Wird unter Umstnden ausgefhrt und zeigt 0 an.
         Console.WriteLine(m_value);
      }
   }
}

internal sealed class VolatileMethods {
   private Byte  m_initialized = 0;
   private Int32 m_value = 0;

   // Diese Methode wird vom ersten Thread ausgefhrt.
   private void Thread1() {
      m_value = 5;
      Thread.VolatileWrite(ref m_initialized, 1);
   }

   // Diese Methode wird vom zweiten Thread ausgefhrt.
   private void Thread2() {
      if (Thread.VolatileRead(ref m_initialized) == 1) {
         // Falls wir hierher kommen, wird 5 angezeigt.
         Console.WriteLine(m_value);
      }
   }
}

internal sealed class VolatileField {
   private volatile Byte m_initialized = 0;
   private Int32 m_value = 0;

   // Diese Methode wird vom ersten Thread ausgefhrt.
   private void Thread1() {
      m_value = 5;
      m_initialized = 1;
   }

   // Diese Methode wird vom zweiten Thread ausgefhrt.
   private void Thread2() {
      if (m_initialized == 1) {
         // Falls wir hierher kommen, wird 5 angezeigt.
         Console.WriteLine(m_value);
      }
   }
   private void CantPassVolatileFieldByReference() {
      // Fr diese Zeile gibt der C#-Compiler eine Warnung aus:
      // CS0420: Ein Verweis auf ein flchtiges Feld wird nicht als flchtig behandelt.
      Boolean success = Byte.TryParse("123", out m_initialized);
   }
}