using System;
using System.Threading;

public sealed class SomeType
{
   // Dies ist die Finalize-Methode von SomeType.
   ~SomeType()
   {
      // Fr Demonstrationszwecke soll der Abschlussthread der CLR
      // versuchen, in die Sperre des Objekts einzutreten.
      // HINWEIS: Da der Hauptthread Besitzer der Sperre des Objekts ist,
      // befindet sich der Abschlussthread in einem Deadlock!
      Monitor.Enter(this);
   }
}

public static class Program
{
   public static void Main()
   {
      // Ein SomeType-Objekt anlegen.
      SomeType st = new SomeType();

      // Dieser bswillige Code tritt in die Sperre des Objekts ein,
      // verlsst sie aber nie mehr.
      Monitor.Enter(st);

      // Fr Demonstrationszwecke erzwingen wir eine Garbage Collection und
      // warten, dass die Finalize-Methoden ihre Arbeit beenden.
      st = null;
      GC.Collect();
      GC.WaitForPendingFinalizers();

      Console.WriteLine("Hier kommen wir nie an, beide Threads sind in einem Deadlock!");
   }
}
